{
    "$graph": [
        {
            "hints": [
                {
                    "dockerPull": "duplexa/4dn-repliseq:v13",
                    "class": "DockerRequirement"
                }
            ],
            "arguments": [],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "type": [
                        "File"
                    ],
                    "id": "#align.cwl/fastq1",
                    "inputBinding": {
                        "position": 1,
                        "separate": true
                    }
                },
                {
                    "type": [
                        "File"
                    ],
                    "id": "#align.cwl/bwa_index",
                    "inputBinding": {
                        "position": 2,
                        "separate": true
                    }
                },
                {
                    "type": [
                        "int"
                    ],
                    "id": "#align.cwl/nThreads",
                    "inputBinding": {
                        "position": 5,
                        "separate": true
                    },
                    "default": 4
                },
                {
                    "type": [
                        "string"
                    ],
                    "id": "#align.cwl/prefix",
                    "inputBinding": {
                        "position": 4,
                        "separate": true
                    },
                    "default": "out"
                },
                {
                    "type": [
                        "string"
                    ],
                    "id": "#align.cwl/outdir",
                    "inputBinding": {
                        "position": 3,
                        "separate": true
                    },
                    "default": "."
                }
            ],
            "baseCommand": [
                "run-align.sh"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "id": "#align.cwl",
            "outputs": [
                {
                    "type": [
                        "File"
                    ],
                    "id": "#align.cwl/out_bam",
                    "outputBinding": {
                        "glob": "*.bam"
                    }
                }
            ]
        },
        {
            "hints": [
                {
                    "dockerPull": "duplexa/4dn-repliseq:v13",
                    "class": "DockerRequirement"
                }
            ],
            "arguments": [],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "type": [
                        "File"
                    ],
                    "id": "#clip.cwl/input_fastq",
                    "inputBinding": {
                        "position": 1,
                        "separate": true
                    }
                },
                {
                    "type": [
                        "string"
                    ],
                    "id": "#clip.cwl/outprefix",
                    "inputBinding": {
                        "position": 2,
                        "separate": true
                    },
                    "default": "out"
                },
                {
                    "type": [
                        "string"
                    ],
                    "id": "#clip.cwl/outdir",
                    "inputBinding": {
                        "position": 1,
                        "separate": true
                    },
                    "default": "."
                }
            ],
            "outputs": [
                {
                    "type": [
                        "File"
                    ],
                    "id": "#clip.cwl/out_clipped_fastq",
                    "outputBinding": {
                        "glob": "$(inputs.outdir + '/' + inputs.outprefix + '.clip.fastq')"
                    }
                },
                {
                    "type": [
                        "File"
                    ],
                    "id": "#clip.cwl/out_log",
                    "outputBinding": {
                        "glob": "$(inputs.outdir + '/' + inputs.outprefix + '.clip.fastq.log')"
                    }
                }
            ],
            "baseCommand": [
                "clip"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "id": "#clip.cwl"
        },
        {
            "hints": [
                {
                    "dockerPull": "duplexa/4dn-repliseq:v13",
                    "class": "DockerRequirement"
                }
            ],
            "arguments": [],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "type": [
                        "File"
                    ],
                    "id": "#count.cwl/input_bam",
                    "inputBinding": {
                        "position": 1,
                        "separate": true
                    }
                },
                {
                    "type": [
                        "File"
                    ],
                    "inputBinding": {
                        "separate": true,
                        "position": 2
                    },
                    "id": "#count.cwl/chrsizes"
                },
                {
                    "type": [
                        "int"
                    ],
                    "id": "#count.cwl/winsize",
                    "inputBinding": {
                        "position": 5,
                        "separate": true
                    },
                    "default": 5000
                },
                {
                    "type": [
                        "string"
                    ],
                    "id": "#count.cwl/outprefix",
                    "inputBinding": {
                        "position": 4,
                        "separate": true
                    },
                    "default": "out"
                },
                {
                    "type": [
                        "string"
                    ],
                    "id": "#count.cwl/outdir",
                    "inputBinding": {
                        "position": 3,
                        "separate": true
                    },
                    "default": "."
                }
            ],
            "outputs": [
                {
                    "type": [
                        "File"
                    ],
                    "id": "#count.cwl/out_count_bg",
                    "secondaryFiles": [
                        "^^.bw",
                        ".px2"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.outdir + '/' + inputs.outprefix + '.w' + inputs.winsize + '.bedGraph.gz')"
                    }
                }
            ],
            "baseCommand": [
                "run-count.sh"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "id": "#count.cwl"
        },
        {
            "hints": [
                {
                    "dockerPull": "duplexa/4dn-repliseq:v13",
                    "class": "DockerRequirement"
                }
            ],
            "arguments": [],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "type": [
                        "File"
                    ],
                    "id": "#dedup.cwl/input_bam",
                    "inputBinding": {
                        "position": 1,
                        "separate": true
                    }
                },
                {
                    "type": [
                        "string"
                    ],
                    "id": "#dedup.cwl/outprefix",
                    "inputBinding": {
                        "position": 3,
                        "separate": true
                    },
                    "default": "out"
                },
                {
                    "type": [
                        "string"
                    ],
                    "id": "#dedup.cwl/outdir",
                    "inputBinding": {
                        "position": 2,
                        "separate": true
                    },
                    "default": "."
                }
            ],
            "outputs": [
                {
                    "type": [
                        "File"
                    ],
                    "id": "#dedup.cwl/out_deduped_bam",
                    "outputBinding": {
                        "glob": "$(inputs.outdir + '/' + inputs.outprefix + '.rmdup.bam')"
                    }
                },
                {
                    "type": [
                        "File"
                    ],
                    "id": "#dedup.cwl/out_qc_report",
                    "outputBinding": {
                        "glob": "$(inputs.outdir + '/' + inputs.outprefix + '.rmdup.log.qc_report.zip')"
                    }
                }
            ],
            "baseCommand": [
                "run-dedup.sh"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "id": "#dedup.cwl"
        },
        {
            "hints": [
                {
                    "dockerPull": "duplexa/4dn-repliseq:v13",
                    "class": "DockerRequirement"
                }
            ],
            "arguments": [],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "type": [
                        "File"
                    ],
                    "id": "#filtersort.cwl/input_bam",
                    "inputBinding": {
                        "position": 1,
                        "separate": true
                    }
                },
                {
                    "type": [
                        "int"
                    ],
                    "id": "#filtersort.cwl/nthreads",
                    "inputBinding": {
                        "position": 3,
                        "separate": true
                    },
                    "default": 1
                },
                {
                    "type": [
                        "string"
                    ],
                    "id": "#filtersort.cwl/memperthread",
                    "inputBinding": {
                        "position": 2,
                        "separate": true
                    },
                    "default": "5G"
                },
                {
                    "type": [
                        "string"
                    ],
                    "id": "#filtersort.cwl/outprefix",
                    "inputBinding": {
                        "position": 5,
                        "separate": true
                    },
                    "default": "out"
                },
                {
                    "type": [
                        "string"
                    ],
                    "id": "#filtersort.cwl/outdir",
                    "inputBinding": {
                        "position": 4,
                        "separate": true
                    },
                    "default": "."
                }
            ],
            "outputs": [
                {
                    "type": [
                        "File"
                    ],
                    "id": "#filtersort.cwl/out_filtered_sorted_bam",
                    "outputBinding": {
                        "glob": "$(inputs.outdir + '/' + inputs.outprefix + '.q20_sort.bam')"
                    }
                }
            ],
            "baseCommand": [
                "filtersort"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "id": "#filtersort.cwl"
        },
        {
            "class": "Workflow",
            "fdn_meta": {
                "category": "align + filter + count",
                "data_types": [
                    "Repli-seq"
                ],
                "description": "This is a subworkflow of the Repli-seq data processing pipeline. It takes a raw fastq file, aligns to the reference genome, performs filtering and reports read counts in a bedgraph (bg) format.",
                "name": "#main/repliseq-parta",
                "title": "Repli-seq data processing pipeline for alignment, filtering and counting",
                "workflow_type": "Repli-seq data processing"
            },
            "inputs": [
                {
                    "fdn_format": "fastq",
                    "id": "#main/fastq",
                    "type": [
                        "File"
                    ]
                },
                {
                    "fdn_format": "bwaIndex",
                    "id": "#main/bwaIndex",
                    "type": [
                        "File"
                    ]
                },
                {
                    "fdn_format": "chromsizes",
                    "id": "#main/chromsizes",
                    "type": [
                        "File"
                    ]
                },
                {
                    "default": 4,
                    "id": "#main/nthreads",
                    "type": [
                        "int"
                    ]
                },
                {
                    "default": "2G",
                    "id": "#main/memperthread",
                    "type": [
                        "string"
                    ]
                },
                {
                    "default": 5000,
                    "id": "#main/winsize",
                    "type": [
                        "int"
                    ]
                }
            ],
            "outputs": [
                {
                    "fdn_format": "bam",
                    "fdn_output_type": "processed",
                    "id": "#main/filtered_sorted_deduped_bam",
                    "outputSource": "#main/dedup/out_deduped_bam",
                    "type": [
                        "File"
                    ]
                },
                {
                    "fdn_output_type": "QC",
                    "id": "#main/dedup_qc_report",
                    "outputSource": "#main/dedup/out_qc_report",
                    "type": [
                        "File"
                    ]
                },
                {
                    "fdn_format": "bg",
                    "fdn_output_type": "processed",
                    "fdn_secondary_file_formats": [
                        "bg_px2",
                        "bw"
                    ],
                    "id": "#main/count_bg",
                    "outputSource": "#main/count/out_count_bg",
                    "type": [
                        "File"
                    ]
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "steps": [
                {
                    "fdn_step_meta": {
                        "analysis_step_types": [
                            "adapter removal"
                        ],
                        "description": "Adapter removal according to the Repli-seq pipeline",
                        "software_used": [
                            "cutadapt_1.14",
                            "repli-seq-pipeline_74bb1d"
                        ]
                    },
                    "id": "#main/clip",
                    "in": [
                        {
                            "arg_name": "input_fastq",
                            "fdn_cardinality": "single",
                            "fdn_format": "fastq",
                            "fdn_type": "data file",
                            "id": "#main/clip/input_fastq",
                            "source": "#main/fastq"
                        }
                    ],
                    "out": [
                        {
                            "arg_name": "out_clipped_fastq",
                            "fdn_cardinality": "single",
                            "fdn_format": "fastq",
                            "id": "#main/clip/out_clipped_fastq"
                        }
                    ],
                    "run": "#clip.cwl"
                },
                {
                    "fdn_step_meta": {
                        "analysis_step_types": [
                            "alignment"
                        ],
                        "description": "Alignment according to the Repli-seq pipeline",
                        "software_used": [
                            "bwa_0.7.15",
                            "repli-seq-pipeline_74bb1d"
                        ]
                    },
                    "id": "#main/align",
                    "in": [
                        {
                            "arg_name": "fastq1",
                            "fdn_cardinality": "single",
                            "fdn_format": "fastq",
                            "id": "#main/align/fastq1",
                            "source": "#main/clip/out_clipped_fastq"
                        },
                        {
                            "arg_name": "bwa_index",
                            "fdn_cardinality": "single",
                            "fdn_format": "bwaIndex",
                            "fdn_type": "reference file",
                            "id": "#main/align/bwa_index",
                            "source": "#main/bwaIndex"
                        },
                        {
                            "arg_name": "nThreads",
                            "fdn_cardinality": "single",
                            "fdn_type": "parameter",
                            "id": "#main/align/nThreads",
                            "source": "#main/nthreads"
                        }
                    ],
                    "out": [
                        {
                            "arg_name": "out_bam",
                            "fdn_cardinality": "single",
                            "fdn_format": "bam",
                            "id": "#main/align/out_bam"
                        }
                    ],
                    "run": "#align.cwl"
                },
                {
                    "fdn_step_meta": {
                        "analysis_step_types": [
                            "filtering",
                            "sorting"
                        ],
                        "description": "Filtering and sorting according to the Repli-seq pipeline",
                        "software_used": [
                            "samtools_1.4",
                            "repli-seq-pipeline_74bb1d"
                        ]
                    },
                    "id": "#main/filtersort",
                    "in": [
                        {
                            "arg_name": "input_bam",
                            "fdn_cardinality": "single",
                            "fdn_format": "bam",
                            "id": "#main/filtersort/input_bam",
                            "source": "#main/align/out_bam"
                        },
                        {
                            "arg_name": "nthreads",
                            "fdn_cardinality": "single",
                            "fdn_type": "parameter",
                            "id": "#main/filtersort/nthreads",
                            "source": "#main/nthreads"
                        },
                        {
                            "arg_name": "memperthread",
                            "fdn_cardinality": "single",
                            "fdn_type": "parameter",
                            "id": "#main/filtersort/memperthread",
                            "source": "#main/memperthread"
                        }
                    ],
                    "out": [
                        {
                            "arg_name": "out_filtered_sorted_bam",
                            "fdn_cardinality": "single",
                            "fdn_format": "bam",
                            "id": "#main/filtersort/out_filtered_sorted_bam"
                        }
                    ],
                    "run": "#filtersort.cwl"
                },
                {
                    "fdn_step_meta": {
                        "analysis_step_types": [
                            "duplicate removal"
                        ],
                        "description": "PCR Duplicate removal according to the Repli-seq pipeline",
                        "software_used": [
                            "samtools_1.4",
                            "repli-seq-pipeline_74bb1d"
                        ]
                    },
                    "id": "#main/dedup",
                    "in": [
                        {
                            "arg_name": "input_bam",
                            "fdn_cardinality": "single",
                            "fdn_format": "bam",
                            "id": "#main/dedup/input_bam",
                            "source": "#main/filtersort/out_filtered_sorted_bam"
                        }
                    ],
                    "out": [
                        {
                            "arg_name": "out_deduped_bam",
                            "fdn_cardinality": "single",
                            "fdn_format": "bam",
                            "fdn_type": "data file",
                            "id": "#main/dedup/out_deduped_bam"
                        },
                        {
                            "arg_name": "out_qc_report",
                            "fdn_cardinality": "single",
                            "fdn_type": "QC",
                            "id": "#main/dedup/out_qc_report"
                        }
                    ],
                    "run": "#dedup.cwl"
                },
                {
                    "fdn_step_meta": {
                        "analysis_step_types": [
                            "binning",
                            "aggregation"
                        ],
                        "description": "Read aggregation according to the Repli-seq pipeline",
                        "software_used": [
                            "bedtools_2.26.0",
                            "repli-seq-pipeline_74bb1d",
                            "pairix_0.3.5",
                            "bedGraphToBigWig_v302.1.0"
                        ]
                    },
                    "id": "#main/count",
                    "in": [
                        {
                            "arg_name": "input_bam",
                            "fdn_cardinality": "single",
                            "fdn_format": "bam",
                            "fdn_type": "data file",
                            "id": "#main/count/input_bam",
                            "source": "#main/dedup/out_deduped_bam"
                        },
                        {
                            "arg_name": "chrsizes",
                            "fdn_cardinality": "single",
                            "fdn_format": "chromsize",
                            "fdn_type": "reference file",
                            "id": "#main/count/chrsizes",
                            "source": "#main/chromsizes"
                        },
                        {
                            "arg_name": "winsize",
                            "fdn_cardinality": "single",
                            "fdn_type": "parameter",
                            "id": "#main/count/winsize",
                            "source": "#main/winsize"
                        }
                    ],
                    "out": [
                        {
                            "arg_name": "out_count_bg",
                            "fdn_cardinality": "single",
                            "fdn_format": "bg",
                            "fdn_type": "data file",
                            "id": "#main/count/out_count_bg"
                        }
                    ],
                    "run": "#count.cwl"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
